"use strict";

/**
 * Pinboard theme definition.
 * @constructor
 */
var ViewExtensionTheme = function() {

	// This is wrapped in a constructor function,
	// so the theme texts can be localized.
	var UI_TEXT = {

	};

	return {

		// Theme properties mapped to dashboard's css selector rules.
		mappings: {

			// List of theme properties that hold image resources.
			// (They should be converted to dataURIs before mapping.)
			resources: {},

			// Define how theme properties map to css rule's property.
			// Broken down by theme section.
			style: {

				"listingTheme": [
					{
						// Active Group Header.
						selector: ".viewext-group-listing-header",
						properties: {
							"color": "sortableHeader_TextColor_Active",
							"background-color": "sortableHeader_BackgroundColor_Active",
							"border-color": "sortableHeader_DividerColor_Active"
						}
					},
					{
						// Inactive Group Header.
						selector: ".inactive .viewext-group-listing-header",
						properties: {
							"color": "sortableHeader_TextColor_Inactive",
							"background-color": "sortableHeader_BackgroundColor_Inactive",
							"border-color": "sortableHeader_DividerColor_Inactive"
						}
					},
					{
						// Item.
						selector: ".viewext-group-level-object",
						properties: {
							"color": "item_TextColor_Normal"
						}
					},
					{
						// Hovered Item.
						selector: ".viewext-group-level-object.selectable:hover",
						properties: {
							"color": "item_TextColor_Hot",
							"background-color": "item_BackgroundColor_Hot",
							"border-color": "item_BackgroundColor_Hot"
						}
					},
					{
						// Selected Item.
						selector: ".viewext-group-level-object.selectable.selected",
						properties: {
							"color": "item_TextColor_Selected",
							"background-color": "item_BackgroundColor_Selected",
							"border-color": "item_BackgroundColor_Selected"
						}
					},
					{
						// Hovered Selected Item.
						selector: ".viewext-group-level-object.selectable.selected:hover",
						properties: {
							"color": "item_TextColor_HotSelected",
							"background-color": "item_BackgroundColor_HotSelected",
							"border-color": "item_BackgroundColor_HotSelected"
						}
					},
					{
						// Inactive Selected Item.
						selector: ".inactive .viewext-group-level-object.selectable.selected",
						properties: {
							"color": "item_TextColor_SelectedNoFocus",
							"background-color": "item_BackgroundColor_SelectedNoFocus",
							"border-color": "item_BackgroundColor_SelectedNoFocus"
						}
					}
				]

			},  // end style

			// Define images that may be re-colored 
			// based on theme properties. 
			// Broken down by section.
			images: {
			
				"listingTheme": {
					expandCollapseIcons: {
						color: "sortableHeader_TextColor_Active",
						images: [
							{ selector: ".viewext-group-listing.expanded .expando", src: "images/collapse-2018.png" },
							{ selector: ".viewext-group-listing.collapsed .expando", src: "images/expand-2018.png" },
							{ selector: ".viewext-group-listing.semi-collapsed .expando", src: "images/semi-collapse-2018.png" }
						]
					}
				}
			}

		}  // end defaultMapping
	};

}  // end PinboardTheme