﻿
function DebuggingConsole( shellUI ) {

	var enabled = false;

	this.ui = shellUI;
	this.buffer = [];

	var self = this;

	// bind to shellUI start event
	shellUI.Events.Register( MFiles.Event.Started, function() {
		self.launchConsole();
	} );

	this.launchConsole = function() {

		if( !enabled )
			return;

		var customData = {
			registerLoggingFunction: function( f ) {

				// register the function
				self.dashboardLog = f;

				self.dashboardLog( "Console loaded. version 0.1a" );

				// purge the buffer.
				for( var i = 0; i < self.buffer.length; i++ ) {
					self.log( self.buffer[i] );
				}
			}
		};

		this.ui.ShowPopupDashboard( "console", false, customData );
	}


	this.log = function( msg ) {

		if( !enabled )
			return;
		else if( this.dashboardLog )
			try {
				this.dashboardLog( msg );
			} catch( e ) { }
		else
			this.buffer.push( msg );
	}

	this.dump = function( name, obj ) {
		var str = name + ": {\n";

		for( var p in obj ) {

			//Skip functions
			if( obj[p] && ( {} ).toString.call( obj[p] ) == '[object Function]' )
				continue;

			str += "  " + p + ": " + obj[p] + "\n";
		}

		str += "}";

		this.log( str );

	}

}