"use strict"

// Define global alert function placeholder.
var alert = function(msg) {}

/*
* Entry point for the ShellUI module.
* Triggered for each time a new shellUI window is opened.
*
* @param {MFiles.ShellUI} shellUI - The new shellUI.
*/
function OnNewShellUI( shellUI ) {

	// No ViewExtensions in web.
	if( MFiles.CurrentApplicationPlatform === MFExtApplicationPlatformWeb ) return {};

	// Implement global alert function.
	alert = function(msg) {
		shellUI.ShowMessage({message:msg.toString()});
	}

	// Load debugging console.
	console.initialize( shellUI, "view-ext" );

	// Register the new shellUI with our detail listing manager.
	var vx = new ViewExtensions();
	vx.registerNewShellUI( shellUI );

	// Expose tests if they were loaded.
	if( TestClient ) {
		TestClient.getInstance().startListening( shellUI, "View Extensions" );
	}

}