"use strict";

( function() {

	// Create simple test declaration object.
	var declaration = {
		id: "viewext.namedvaluesettings",
		name: "NamedValueSettings"
	};

	/**
	 * Declare our tests in a suite method.
	 * @param {IBehaviorDrivenTestMethods} - The mocha methods for declaring behavior driven tests.
	 * @param {Chai.ChaiStatic} - Chai object, used for assertions.
	 */
	declaration.bddSuite = function(
			bdd,
			chai
		) {

		// Resolve common objects.
		var shellUI = TestClient.getInstance().shellUI;
		var vault = shellUI.Vault;

		// Expose key methods.
		var describe = bdd.describe;
		var it = bdd.it;
		var assert = chai.assert;

		describe( "constructor", function() {

			it( "works with valid arguments", function() {
				
				var instance = new NamedValueSettings( vault, 
						MFiles.MFNamedValueType.AdminConfiguration, "ViewExtensions.TestNamespace" );
				assert( instance, "NamedValueSettings instance not created." );
			} )
		} );
	}


	// Register the tests.
	TestClient.getInstance().registerSuite( declaration );

} )();